function [ portfolio, newStateMatrix ] = SWS_Master_III_151117( decisionData, stateMatrix )
%% йҵͶʲ
%A. Ʊӯʵгƽˮƽ 
%B. ƱоС2.5 
%C. ҵʲծ1.2
%D. ҵܽʲ1.5 
%E. 꾻0
%F. һֽ0
%G. ӯTTMΪǰӯ80%
%% ׼
CP = decisionData.CP_DAY01.data;
%A. ӯTTMΪ1
PE = decisionData.PETTM_DAY01.data;
%B. оʣΪ1
PB = decisionData.PB_DAY01.data;
%C. ʲϼ & ʲծȾΪ1
QF_TotCurAssets = decisionData.QF_TotalCurrentAssets_DAY01.data;
QF_TotCurLbt = decisionData.QF_TotalCurrentLbt_DAY01.data;
%D. ROCBӪʽ =ʲϼ-ծϼƣ/ڽ+ڽΪ1
ROCB = decisionData.ROCB_DAY01.data;
%E. QF_NetProfit ꣬Ϊ1250
QF_NetProfit = decisionData.QF_NetProfit_DAY01.data;
%F. ֽ꣬Ϊ125
CashDiv = decisionData.CashDiv_DAY01.data;
%G. GRNPBBBͬȣΪ750
GRNPB = decisionData.GRNPB_DAY01.data;


%% ׼
num = length(decisionData.tickerList);
% Ծݵĵ1ԶΪ:
PsnUnit = decisionData.parameters.PsnUnit;     %Ʊֹ
% Ծݵĵ2ԶΪ:
InvestAmount = decisionData.parameters.InvestAmount;     %˻ܶ
% Ծݵĵ3ԶΪ:
SelectedStkRatio = decisionData.parameters.SelectedStkRatio;     %ƱԤ
% Ծݵĵ4ԶΪ:
ConditionThehold = decisionData.parameters.ConditionThehold;     %ֵ

%% 
condition = nan(num, 7);
%A. Ʊӯʵгƽˮƽ 
condition(:, 1) = PE < nanmean(PE);
%B. ƱоС2.5 
condition(:, 2) = PB < 2.5;
%C. ҵʲծ1.2
condition(:, 3) = QF_TotCurAssets >= 1.2*QF_TotCurLbt;
%D. ҵܽʲ1.5 
condition(:, 4) = ROCB >= 1/1.5;
%E. 꾻0
condition(:, 5) = sum(QF_NetProfit>0, 2) > 1000;
%F. һֽ0
condition(:, 6) = sum(CashDiv, 2) > 0;
%G. ӯTTMGRNPB Ϊǰӯ80%
% function [ valOut ] = GRNPB_cum3Y_calc( valIn )
GRNPB_cum3Y = GRNPB_cum3Y_calc(GRNPB);
condition(:, 7) = GRNPB_cum3Y > 0.8;

conditionTot = sum(condition, 2);
[ conSorted, conIdx ] = sort(conditionTot, 'descend');

if ConditionThehold == 0 %ΪԶ
        ConditionThehold = max(conditionTot);
end

SelectedStkNum = find(conSorted >= ConditionThehold, 1, 'last'); % SelectedStkNum ʾı
StockMaxNum = fix(num *SelectedStkRatio); % StockMaxNum ʾƱԤƵı
if isempty(SelectedStkNum)
        SelectedStkNum = 0;
elseif SelectedStkNum > StockMaxNum 
        StockMaxNum = SelectedStkNum;
end
        
% ʼ
portfolio = zeros(num, 1);
% ǰ stockMaxNum ֻģ
portfolio( conIdx(1: SelectedStkNum ) ) = 1;

many = fix(InvestAmount/StockMaxNum./CP/100) * 100;
many(isnan(many)) = 0;

portfolio = portfolio .* many;

newStateMatrix = 1;

end

function [ valOut ] = GRNPB_cum3Y_calc( valIn )
% input GRNPB index
% output GRNPB cum index 
    num = size(valIn, 1);
    valOut = nan(num, 1);
    for i = 1: num
            valCol = valIn(i, :);
            valCol(isnan(valCol)) = [];
            if length(valCol) == 0 
                    continue;
            end
            valCol = valCol +1;
            valOut(i) = valCol(end);
            if length(valCol) == 1
                    continue;
            end
            valCol2 = valCol(1:end-1);
            valCol3 = valCol2( abs(diff(valCol, 1, 2)) > eps );
            if ~isempty(valCol3)
                    valOut(i) = valOut(i)* prod(valCol3);
            end            
    end
return
end
